From d7d87df542f8c8705b26e185db71df7bed9a84b7 Mon Sep 17 00:00:00 2001
From: Alyssa Rosenzweig <alyssa@rosenzweig.io>
Date: Mon, 24 Feb 2025 14:57:49 -0500
Subject: [PATCH] Via Coccinelle patch:

    @@
    identifier prog;
    expression impl, metadata;
    @@

    -if (prog) {
    -nir_metadata_preserve(impl, metadata);
    -} else {
    -nir_metadata_preserve(impl, nir_metadata_all);
    -}
    -return prog;
    +return nir_progress(prog, impl, metadata);

    @@
    expression prog_expr, impl, metadata;
    @@

    -if (prog_expr) {
    -nir_metadata_preserve(impl, metadata);
    -return true;
    -} else {
    -nir_metadata_preserve(impl, nir_metadata_all);
    -return false;
    -}
    +bool progress = prog_expr;
    +return nir_progress(progress, impl, metadata);

    @@
    identifier prog;
    expression impl, metadata;
    @@

    -nir_metadata_preserve(impl, prog ? (metadata) : nir_metadata_all);
    -return prog;
    +return nir_progress(prog, impl, metadata);

    @@
    identifier prog;
    expression impl, metadata;
    @@

    -nir_metadata_preserve(impl, prog ? (metadata) : nir_metadata_all);
    +nir_progress(prog, impl, metadata);

    @@
    expression impl, metadata;
    @@

    -nir_metadata_preserve(impl, metadata);
    -return true;
    +return nir_progress(true, impl, metadata);

    @@
    expression impl;
    @@

    -nir_metadata_preserve(impl, nir_metadata_all);
    -return false;
    +return nir_no_progress(impl);

    @@
    identifier other_prog, prog;
    expression impl, metadata;
    @@

    -if (prog) {
    -nir_metadata_preserve(impl, metadata);
    -} else {
    -nir_metadata_preserve(impl, nir_metadata_all);
    -}
    -other_prog |= prog;
    +other_prog = other_prog | nir_progress(prog, impl, metadata);

    @@
    identifier prog;
    expression impl, metadata;
    @@

    -if (prog) {
    -nir_metadata_preserve(impl, metadata);
    -} else {
    -nir_metadata_preserve(impl, nir_metadata_all);
    -}
    +nir_progress(prog, impl, metadata);

    @@
    identifier other_prog, prog;
    expression impl, metadata;
    @@

    -if (prog) {
    -nir_metadata_preserve(impl, metadata);
    -other_prog = true;
    -} else {
    -nir_metadata_preserve(impl, nir_metadata_all);
    -}
    +other_prog = other_prog | nir_progress(prog, impl, metadata);

    @@
    expression prog_expr, impl, metadata;
    identifier prog;
    @@

    -if (prog_expr) {
    -nir_metadata_preserve(impl, metadata);
    -prog = true;
    -} else {
    -nir_metadata_preserve(impl, nir_metadata_all);
    -}
    +bool impl_progress = prog_expr;
    +prog = prog | nir_progress(impl_progress, impl, metadata);

    @@
    identifier other_prog, prog;
    expression impl, metadata;
    @@

    -if (prog) {
    -other_prog = true;
    -nir_metadata_preserve(impl, metadata);
    -} else {
    -nir_metadata_preserve(impl, nir_metadata_all);
    -}
    +other_prog = other_prog | nir_progress(prog, impl, metadata);

    @@
    expression prog_expr, impl, metadata;
    identifier prog;
    @@

    -if (prog_expr) {
    -prog = true;
    -nir_metadata_preserve(impl, metadata);
    -} else {
    -nir_metadata_preserve(impl, nir_metadata_all);
    -}
    +bool impl_progress = prog_expr;
    +prog = prog | nir_progress(impl_progress, impl, metadata);

    @@
    expression prog_expr, impl, metadata;
    @@

    -if (prog_expr) {
    -nir_metadata_preserve(impl, metadata);
    -} else {
    -nir_metadata_preserve(impl, nir_metadata_all);
    -}
    +bool impl_progress = prog_expr;
    +nir_progress(impl_progress, impl, metadata);

    @@
    identifier prog;
    expression impl, metadata;
    @@

    -nir_metadata_preserve(impl, metadata);
    -prog = true;
    +prog = nir_progress(true, impl, metadata);

    @@
    identifier prog;
    expression impl, metadata;
    @@

    -if (prog) {
    -nir_metadata_preserve(impl, metadata);
    -}
    -return prog;
    +return nir_progress(prog, impl, metadata);

    @@
    identifier prog;
    expression impl, metadata;
    @@

    -if (prog) {
    -nir_metadata_preserve(impl, metadata);
    -}
    +nir_progress(prog, impl, metadata);

    @@
    expression impl;
    @@

    -nir_metadata_preserve(impl, nir_metadata_all);
    +nir_no_progress(impl);

    @@
    expression impl, metadata;
    @@

    -nir_metadata_preserve(impl, metadata);
    +nir_progress(true, impl, metadata);
---
 src/amd/common/nir/ac_nir_lower_legacy_gs.c   |  3 +-
 src/amd/common/nir/ac_nir_lower_legacy_vs.c   |  4 +-
 src/amd/common/nir/ac_nir_lower_ngg.c         |  6 +--
 src/amd/common/nir/ac_nir_lower_ngg_gs.c      |  6 +--
 src/amd/common/nir/ac_nir_lower_ngg_mesh.c    |  2 +-
 .../nir/ac_nir_lower_taskmesh_io_to_mem.c     |  2 +-
 .../common/nir/ac_nir_lower_tess_io_to_mem.c  |  2 +-
 src/amd/common/nir/ac_nir_lower_tex.c         |  9 +++--
 src/amd/common/nir/ac_nir_opt_outputs.c       | 10 +----
 .../aco_instruction_selection_setup.cpp       |  2 +-
 .../nir/radv_nir_apply_pipeline_layout.c      |  2 +-
 .../vulkan/nir/radv_nir_export_multiview.c    |  7 +---
 src/amd/vulkan/nir/radv_nir_lower_abi.c       |  2 +-
 .../nir/radv_nir_lower_cooperative_matrix.c   |  8 +---
 .../radv_nir_lower_primitive_shading_rate.c   |  7 +---
 .../vulkan/nir/radv_nir_lower_ray_queries.c   |  2 +-
 src/amd/vulkan/nir/radv_nir_rt_shader.c       | 20 +++-------
 src/amd/vulkan/radv_pipeline_rt.c             |  6 +--
 .../compiler/agx_nir_lower_cull_distance.c    |  3 +-
 .../compiler/agx_nir_lower_discard_zs_emit.c  |  9 +----
 .../compiler/agx_nir_lower_sample_mask.c      |  5 +--
 src/asahi/lib/agx_nir_lower_alpha.c           | 14 ++-----
 src/asahi/lib/agx_nir_lower_gs.c              |  2 +-
 src/asahi/lib/agx_nir_lower_msaa.c            |  2 +-
 src/asahi/lib/agx_nir_lower_tess.c            |  4 +-
 src/asahi/lib/agx_nir_prolog_epilog.c         |  6 +--
 src/asahi/vulkan/hk_shader.c                  |  6 +--
 src/broadcom/compiler/v3d_nir_lower_io.c      |  3 +-
 .../compiler/v3d_nir_lower_line_smooth.c      |  7 +---
 .../compiler/v3d_nir_lower_logic_ops.c        |  8 +---
 src/broadcom/compiler/vir.c                   |  6 +--
 src/compiler/clc/nir_load_libclc.c            |  4 +-
 src/compiler/glsl/gl_nir_linker.c             |  6 +--
 .../gl_nir_lower_blend_equation_advanced.c    |  5 +--
 src/compiler/glsl/gl_nir_lower_buffers.c      |  8 +---
 src/compiler/nir/nir.c                        |  8 +---
 src/compiler/nir/nir_builder.c                |  2 +-
 src/compiler/nir/nir_builder.h                | 37 +++---------------
 src/compiler/nir/nir_control_flow.c           |  6 +--
 src/compiler/nir/nir_deref.c                  | 16 +-------
 src/compiler/nir/nir_divergence_analysis.c    |  4 +-
 src/compiler/nir/nir_from_ssa.c               |  4 +-
 src/compiler/nir/nir_group_loads.c            |  4 +-
 src/compiler/nir/nir_inline_uniforms.c        |  2 +-
 src/compiler/nir/nir_linking_helpers.c        | 15 ++------
 src/compiler/nir/nir_lower_amul.c             |  2 +-
 .../nir/nir_lower_array_deref_of_vec.c        | 10 +----
 src/compiler/nir/nir_lower_atomics_to_ssbo.c  |  2 +-
 src/compiler/nir/nir_lower_bit_size.c         |  8 +---
 src/compiler/nir/nir_lower_bitmap.c           |  2 +-
 src/compiler/nir/nir_lower_clip.c             |  6 +--
 .../nir/nir_lower_clip_cull_distance_arrays.c | 10 +----
 .../nir/nir_lower_const_arrays_to_uniforms.c  |  2 +-
 .../nir/nir_lower_continue_constructs.c       |  4 +-
 src/compiler/nir/nir_lower_double_ops.c       |  8 +---
 src/compiler/nir/nir_lower_flrp.c             |  2 +-
 .../nir/nir_lower_global_vars_to_local.c      |  7 ++--
 src/compiler/nir/nir_lower_goto_ifs.c         |  5 +--
 src/compiler/nir/nir_lower_gs_intrinsics.c    |  2 +-
 src/compiler/nir/nir_lower_indirect_derefs.c  |  7 +---
 src/compiler/nir/nir_lower_int_to_float.c     |  6 +--
 src/compiler/nir/nir_lower_io.c               | 35 ++++-------------
 .../nir/nir_lower_io_arrays_to_elements.c     |  6 +--
 .../nir/nir_lower_io_to_temporaries.c         |  5 +--
 src/compiler/nir/nir_lower_io_to_vector.c     |  6 +--
 .../nir/nir_lower_load_const_to_scalar.c      |  8 +---
 src/compiler/nir/nir_lower_locals_to_regs.c   |  2 +-
 src/compiler/nir/nir_lower_mediump.c          | 38 +++----------------
 src/compiler/nir/nir_lower_memcpy.c           |  8 +---
 src/compiler/nir/nir_lower_memory_model.c     |  8 +---
 src/compiler/nir/nir_lower_multiview.c        |  3 +-
 .../nir/nir_lower_non_uniform_access.c        |  5 +--
 .../nir/nir_lower_passthrough_edgeflags.c     |  2 +-
 src/compiler/nir/nir_lower_patch_vertices.c   |  4 +-
 src/compiler/nir/nir_lower_phis_to_scalar.c   |  2 +-
 src/compiler/nir/nir_lower_pntc_ytransform.c  |  2 +-
 src/compiler/nir/nir_lower_point_size_mov.c   |  2 +-
 .../nir/nir_lower_reg_intrinsics_to_ssa.c     |  6 +--
 src/compiler/nir/nir_lower_returns.c          |  4 +-
 src/compiler/nir/nir_lower_scratch.c          |  8 +---
 src/compiler/nir/nir_lower_shader_calls.c     | 24 ++++--------
 src/compiler/nir/nir_lower_task_shader.c      |  6 +--
 .../nir/nir_lower_terminate_to_demote.c       |  8 +---
 src/compiler/nir/nir_lower_tex.c              |  2 +-
 src/compiler/nir/nir_lower_texcoord_replace.c |  2 +-
 .../nir/nir_lower_variable_initializers.c     | 19 +++-------
 src/compiler/nir/nir_lower_vars_to_ssa.c      |  5 +--
 src/compiler/nir/nir_metadata.c               |  2 +-
 .../nir/nir_move_output_stores_to_end.c       |  4 +-
 .../nir/nir_move_vec_src_uses_to_dest.c       |  2 +-
 src/compiler/nir/nir_opt_access.c             | 18 ++-------
 src/compiler/nir/nir_opt_barriers.c           | 20 +++-------
 src/compiler/nir/nir_opt_call.c               |  3 +-
 src/compiler/nir/nir_opt_combine_stores.c     |  7 +---
 src/compiler/nir/nir_opt_comparison_pre.c     |  8 +---
 src/compiler/nir/nir_opt_copy_prop_vars.c     |  7 +---
 src/compiler/nir/nir_opt_copy_propagate.c     |  8 +---
 src/compiler/nir/nir_opt_cse.c                |  6 +--
 src/compiler/nir/nir_opt_dce.c                |  8 +---
 src/compiler/nir/nir_opt_dead_cf.c            |  4 +-
 src/compiler/nir/nir_opt_dead_write_vars.c    |  8 +---
 src/compiler/nir/nir_opt_find_array_copies.c  |  4 +-
 src/compiler/nir/nir_opt_fragdepth.c          |  6 +--
 src/compiler/nir/nir_opt_gcm.c                |  6 +--
 src/compiler/nir/nir_opt_if.c                 |  8 +---
 src/compiler/nir/nir_opt_intrinsics.c         |  9 ++---
 src/compiler/nir/nir_opt_large_constants.c    |  3 +-
 src/compiler/nir/nir_opt_licm.c               | 10 ++---
 .../nir/nir_opt_load_store_vectorize.c        |  5 +--
 src/compiler/nir/nir_opt_loop.c               |  4 +-
 src/compiler/nir/nir_opt_loop_unroll.c        |  4 +-
 src/compiler/nir/nir_opt_memcpy.c             |  8 +---
 src/compiler/nir/nir_opt_move.c               |  8 ++--
 .../nir/nir_opt_move_discards_to_top.c        |  3 +-
 src/compiler/nir/nir_opt_mqsad.c              |  5 +--
 src/compiler/nir/nir_opt_peephole_select.c    |  8 +---
 src/compiler/nir/nir_opt_preamble.c           |  3 +-
 src/compiler/nir/nir_opt_ray_queries.c        |  5 +--
 .../nir/nir_opt_rematerialize_compares.c      | 16 +-------
 src/compiler/nir/nir_opt_shrink_stores.c      |  7 +---
 src/compiler/nir/nir_opt_shrink_vectors.c     |  7 +---
 src/compiler/nir/nir_opt_sink.c               |  3 +-
 src/compiler/nir/nir_opt_uniform_atomics.c    |  9 ++---
 src/compiler/nir/nir_opt_varyings.c           | 12 ++----
 src/compiler/nir/nir_opt_vectorize.c          |  6 +--
 src/compiler/nir/nir_opt_vectorize_io.c       |  5 +--
 src/compiler/nir/nir_propagate_invariant.c    | 10 +----
 src/compiler/nir/nir_repair_ssa.c             |  2 +-
 src/compiler/nir/nir_search.c                 | 11 +-----
 src/compiler/nir/nir_split_vars.c             | 15 +++-----
 src/compiler/nir/nir_sweep.c                  |  2 +-
 src/compiler/nir/nir_to_lcssa.c               |  9 ++---
 src/compiler/nir/nir_trivialize_registers.c   |  2 +-
 src/compiler/nir/nir_use_dominance.c          |  2 +-
 .../ir3/ir3_nir_analyze_ubo_ranges.c          | 11 ++----
 src/freedreno/ir3/ir3_nir_lower_64b.c         |  4 +-
 src/freedreno/ir3/ir3_nir_lower_io_offsets.c  |  7 +---
 .../ir3_nir_lower_push_consts_to_preamble.c   |  2 +-
 src/freedreno/ir3/ir3_nir_lower_tess.c        | 23 +++--------
 .../ir3/ir3_nir_lower_tex_prefetch.c          |  7 +---
 .../ir3/ir3_nir_move_varying_inputs.c         |  5 +--
 src/freedreno/ir3/ir3_nir_opt_preamble.c      | 12 ++----
 .../vulkan/tu_nir_lower_multiview.cc          |  9 ++---
 .../vulkan/tu_nir_lower_ray_query.cc          |  2 +-
 src/gallium/auxiliary/nir/tgsi_to_nir.c       |  3 +-
 .../drivers/asahi/agx_nir_lower_point_size.c  |  4 +-
 src/gallium/drivers/crocus/crocus_program.c   |  5 +--
 .../drivers/d3d12/d3d12_lower_point_sprite.c  |  2 +-
 src/gallium/drivers/d3d12/d3d12_nir_passes.c  | 18 ++++-----
 src/gallium/drivers/etnaviv/etnaviv_nir.c     |  8 +---
 src/gallium/drivers/iris/iris_program.c       |  5 +--
 .../lima/ir/lima_nir_duplicate_consts.c       |  2 +-
 .../lima/ir/lima_nir_duplicate_intrinsic.c    |  2 +-
 .../lima/ir/lima_nir_duplicate_modifiers.c    |  2 +-
 .../sfn/sfn_nir_lower_fs_out_to_vector.cpp    |  7 +---
 .../r600/sfn/sfn_nir_vectorize_vs_inputs.c    |  6 +--
 .../drivers/radeonsi/si_nir_lower_abi.c       |  2 +-
 src/gallium/drivers/radeonsi/si_shader.c      | 14 ++-----
 src/gallium/drivers/radeonsi/si_shader_nir.c  |  8 +---
 src/gallium/drivers/vc4/vc4_nir_lower_blend.c |  3 +-
 src/gallium/drivers/vc4/vc4_nir_lower_io.c    |  4 +-
 src/gallium/drivers/zink/zink_compiler.c      |  5 +--
 .../lavapipe/lvp_ray_tracing_pipeline.c       |  7 +---
 .../lavapipe/nir/lvp_nir_lower_ray_queries.c  |  2 +-
 .../rogue/nir/rogue_nir_lower_io.c            |  7 +---
 src/intel/compiler/brw_compile_mesh.cpp       |  6 +--
 src/intel/compiler/brw_kernel.c               |  8 +---
 src/intel/compiler/brw_nir.c                  |  3 +-
 .../brw_nir_lower_alpha_to_coverage.c         |  6 +--
 .../compiler/brw_nir_lower_cs_intrinsics.c    |  3 +-
 .../brw_nir_lower_intersection_shader.c       |  2 +-
 .../compiler/brw_nir_lower_ray_queries.c      |  4 +-
 .../compiler/brw_nir_lower_rt_intrinsics.c    |  6 +--
 .../compiler/brw_nir_lower_shader_calls.c     |  2 +-
 src/intel/compiler/brw_nir_opt_fsat.c         |  8 +---
 src/intel/compiler/brw_nir_rt.c               | 16 +-------
 .../elk/elk_nir_lower_alpha_to_coverage.c     |  6 +--
 .../elk/elk_nir_lower_cs_intrinsics.c         |  3 +-
 .../compiler/intel_nir_tcs_workarounds.c      |  2 +-
 src/intel/vulkan/anv_nir_lower_multiview.c    |  4 +-
 .../vulkan_hasvk/anv_nir_lower_multiview.c    |  4 +-
 .../st_nir_lower_position_invariant.c         |  4 +-
 src/microsoft/clc/clc_nir.c                   |  8 +---
 src/microsoft/compiler/dxil_nir.c             |  8 +---
 src/microsoft/compiler/dxil_nir_tess.c        |  2 +-
 src/nouveau/codegen/nv50_ir_from_nir.cpp      |  3 +-
 src/nouveau/compiler/nak_nir_lower_cf.c       |  3 +-
 .../compiler/nak_nir_lower_gs_intrinsics.c    |  2 +-
 .../compiler/nak_nir_lower_non_uniform_ldcx.c |  9 +----
 .../compiler/nak_nir_mark_lcssa_invariants.c  | 10 ++---
 src/panfrost/midgard/nir_fuse_io_16.c         |  3 +-
 src/panfrost/util/pan_lower_writeout.c        |  4 +-
 192 files changed, 349 insertions(+), 909 deletions(-)

diff --git a/src/amd/common/nir/ac_nir_lower_legacy_gs.c b/src/amd/common/nir/ac_nir_lower_legacy_gs.c
index 261399dd0fd..066db3b7419 100644
--- a/src/amd/common/nir/ac_nir_lower_legacy_gs.c
+++ b/src/amd/common/nir/ac_nir_lower_legacy_gs.c
@@ -284,8 +284,7 @@ ac_nir_lower_legacy_gs(nir_shader *nir,
    nir_sendmsg_amd(b, nir_load_gs_wave_id_amd(b),
                    .base = AC_SENDMSG_GS_OP_NOP | AC_SENDMSG_GS_DONE);
 
-   if (progress)
-      nir_metadata_preserve(impl, nir_metadata_none);
+   nir_progress(progress, impl, nir_metadata_none);
 
    return true;
 }
diff --git a/src/amd/common/nir/ac_nir_lower_legacy_vs.c b/src/amd/common/nir/ac_nir_lower_legacy_vs.c
index a1246baee11..3c160f009a9 100644
--- a/src/amd/common/nir/ac_nir_lower_legacy_vs.c
+++ b/src/amd/common/nir/ac_nir_lower_legacy_vs.c
@@ -89,7 +89,5 @@ ac_nir_lower_legacy_vs(nir_shader *nir,
                                &out);
    }
 
-   nir_metadata_preserve(impl, nir_metadata_none);
-
-   return true;
+   return nir_progress(true, impl, nir_metadata_none);
 }
diff --git a/src/amd/common/nir/ac_nir_lower_ngg.c b/src/amd/common/nir/ac_nir_lower_ngg.c
index c53a90984d7..b2005ac1a20 100644
--- a/src/amd/common/nir/ac_nir_lower_ngg.c
+++ b/src/amd/common/nir/ac_nir_lower_ngg.c
@@ -838,7 +838,7 @@ analyze_shader_before_culling(nir_shader *shader, lower_ngg_nogs_state *s)
          }
       }
 
-      nir_metadata_preserve(impl, nir_metadata_all);
+      nir_no_progress(impl);
    }
 }
 
@@ -1203,7 +1203,7 @@ add_deferred_attribute_culling(nir_builder *b, nir_cf_list *original_extracted_c
    nir_store_var(b, s->gs_accepted_var, gs_thread, 0x1u);
 
    /* Remove all non-position outputs, and put the position output into the variable. */
-   nir_metadata_preserve(impl, nir_metadata_none);
+   nir_progress(true, impl, nir_metadata_none);
    remove_culling_shader_outputs(b->shader, s);
    b->cursor = nir_after_impl(impl);
 
@@ -1929,7 +1929,7 @@ ac_nir_lower_ngg_nogs(nir_shader *shader, const ac_nir_lower_ngg_options *option
       }
    }
 
-   nir_metadata_preserve(impl, nir_metadata_none);
+   nir_progress(true, impl, nir_metadata_none);
    nir_validate_shader(shader, "after emitting NGG VS/TES");
 
    /* Cleanup */
diff --git a/src/amd/common/nir/ac_nir_lower_ngg_gs.c b/src/amd/common/nir/ac_nir_lower_ngg_gs.c
index 564348ea3bd..72946fd2b2a 100644
--- a/src/amd/common/nir/ac_nir_lower_ngg_gs.c
+++ b/src/amd/common/nir/ac_nir_lower_ngg_gs.c
@@ -957,13 +957,11 @@ ac_nir_lower_ngg_gs(nir_shader *shader, const ac_nir_lower_ngg_options *options)
    ngg_gs_finale(b, &state);
 
    /* Take care of metadata and validation before calling other passes */
-   nir_metadata_preserve(impl, nir_metadata_none);
+   nir_progress(true, impl, nir_metadata_none);
    nir_validate_shader(shader, "after emitting NGG GS");
 
    /* Cleanup */
    nir_lower_vars_to_ssa(shader);
    nir_remove_dead_variables(shader, nir_var_function_temp, NULL);
-   nir_metadata_preserve(impl, nir_metadata_none);
-
-   return true;
+   return nir_progress(true, impl, nir_metadata_none);
 }
diff --git a/src/amd/common/nir/ac_nir_lower_ngg_mesh.c b/src/amd/common/nir/ac_nir_lower_ngg_mesh.c
index 846e2ee1afc..5492d9c7977 100644
--- a/src/amd/common/nir/ac_nir_lower_ngg_mesh.c
+++ b/src/amd/common/nir/ac_nir_lower_ngg_mesh.c
@@ -1429,7 +1429,7 @@ ac_nir_lower_ngg_mesh(nir_shader *shader,
    emit_ms_finale(b, &state);
 
    /* Take care of metadata and validation before calling other passes */
-   nir_metadata_preserve(impl, nir_metadata_none);
+   nir_progress(true, impl, nir_metadata_none);
    nir_validate_shader(shader, "after emitting NGG MS");
 
    /* Cleanup */
diff --git a/src/amd/common/nir/ac_nir_lower_taskmesh_io_to_mem.c b/src/amd/common/nir/ac_nir_lower_taskmesh_io_to_mem.c
index 2d39039c870..015ee36a33d 100644
--- a/src/amd/common/nir/ac_nir_lower_taskmesh_io_to_mem.c
+++ b/src/amd/common/nir/ac_nir_lower_taskmesh_io_to_mem.c
@@ -306,7 +306,7 @@ ac_nir_lower_task_outputs_to_mem(nir_shader *shader,
        * that are made by lower_task_launch_mesh_workgroups.
        */
       nir_function_impl *impl = nir_shader_get_entrypoint(shader);
-      nir_metadata_preserve(impl, nir_metadata_none);
+      nir_progress(true, impl, nir_metadata_none);
    }
 
    return progress;
diff --git a/src/amd/common/nir/ac_nir_lower_tess_io_to_mem.c b/src/amd/common/nir/ac_nir_lower_tess_io_to_mem.c
index 9e2468db53b..10d752b0c45 100644
--- a/src/amd/common/nir/ac_nir_lower_tess_io_to_mem.c
+++ b/src/amd/common/nir/ac_nir_lower_tess_io_to_mem.c
@@ -1113,7 +1113,7 @@ hs_finale(nir_shader *shader, lower_tess_io_state *st)
    }
    nir_pop_if(b, if_invocation_id_zero);
 
-   nir_metadata_preserve(impl, nir_metadata_none);
+   nir_progress(true, impl, nir_metadata_none);
 }
 
 static nir_def *
diff --git a/src/amd/common/nir/ac_nir_lower_tex.c b/src/amd/common/nir/ac_nir_lower_tex.c
index bdd1fd3d849..935710086f0 100644
--- a/src/amd/common/nir/ac_nir_lower_tex.c
+++ b/src/amd/common/nir/ac_nir_lower_tex.c
@@ -495,10 +495,11 @@ ac_nir_lower_tex(nir_shader *nir, const ac_nir_lower_tex_options *options)
       state.num_wqm_vgprs = 0;
 
       bool divergent_discard = false;
-      if (move_coords_from_divergent_cf(&state, impl, &impl->body, &divergent_discard, false))
-         nir_metadata_preserve(impl, nir_metadata_control_flow);
-      else
-         nir_metadata_preserve(impl, nir_metadata_all);
+      bool impl_progress = move_coords_from_divergent_cf(&state, impl,
+                                                         &impl->body,
+                                                         &divergent_discard,
+                                                         false);
+      nir_progress(impl_progress, impl, nir_metadata_control_flow);
    }
 
    progress |= nir_shader_instructions_pass(
diff --git a/src/amd/common/nir/ac_nir_opt_outputs.c b/src/amd/common/nir/ac_nir_opt_outputs.c
index c04e146e146..3ae14222633 100644
--- a/src/amd/common/nir/ac_nir_opt_outputs.c
+++ b/src/amd/common/nir/ac_nir_opt_outputs.c
@@ -232,8 +232,7 @@ bool ac_nir_optimize_outputs(nir_shader *nir, bool sprite_tex_disallowed,
 
    if (nir->info.stage != MESA_SHADER_VERTEX &&
        nir->info.stage != MESA_SHADER_TESS_EVAL) {
-      nir_metadata_preserve(impl, nir_metadata_all);
-      return false;
+      return nir_no_progress(impl);
    }
 
    struct ac_out_info outputs[NUM_TOTAL_VARYING_SLOTS] = { 0 };
@@ -300,10 +299,5 @@ bool ac_nir_optimize_outputs(nir_shader *nir, bool sprite_tex_disallowed,
          ac_eliminate_duplicated_output(outputs, outputs_optimized, i, &b, slot_remap);
    }
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_control_flow);
 }
diff --git a/src/amd/compiler/aco_instruction_selection_setup.cpp b/src/amd/compiler/aco_instruction_selection_setup.cpp
index f89c12bbf58..72661e0c5a8 100644
--- a/src/amd/compiler/aco_instruction_selection_setup.cpp
+++ b/src/amd/compiler/aco_instruction_selection_setup.cpp
@@ -373,7 +373,7 @@ init_context(isel_context* ctx, nir_shader* shader)
 
    /* sanitize control flow */
    sanitize_cf_list(impl, &impl->body);
-   nir_metadata_preserve(impl, nir_metadata_none);
+   nir_progress(true, impl, nir_metadata_none);
 
    /* we'll need these for isel */
    nir_metadata_require(impl, nir_metadata_block_index);
diff --git a/src/amd/vulkan/nir/radv_nir_apply_pipeline_layout.c b/src/amd/vulkan/nir/radv_nir_apply_pipeline_layout.c
index 2b6744b4c05..aee15283b79 100644
--- a/src/amd/vulkan/nir/radv_nir_apply_pipeline_layout.c
+++ b/src/amd/vulkan/nir/radv_nir_apply_pipeline_layout.c
@@ -591,7 +591,7 @@ radv_nir_apply_pipeline_layout(nir_shader *shader, struct radv_device *device, c
 
    if (progress) {
       nir_foreach_function (function, shader) {
-         nir_metadata_preserve(function->impl, nir_metadata_control_flow);
+         nir_progress(true, function->impl, nir_metadata_control_flow);
       }
    }
 
diff --git a/src/amd/vulkan/nir/radv_nir_export_multiview.c b/src/amd/vulkan/nir/radv_nir_export_multiview.c
index 24630e7498e..bb67d0f0514 100644
--- a/src/amd/vulkan/nir/radv_nir_export_multiview.c
+++ b/src/amd/vulkan/nir/radv_nir_export_multiview.c
@@ -82,10 +82,5 @@ radv_nir_export_multiview(nir_shader *nir)
          break;
    }
 
-   if (progress)
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   else
-      nir_metadata_preserve(impl, nir_metadata_all);
-
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_control_flow);
 }
diff --git a/src/amd/vulkan/nir/radv_nir_lower_abi.c b/src/amd/vulkan/nir/radv_nir_lower_abi.c
index 041515c259e..8eb24c75b62 100644
--- a/src/amd/vulkan/nir/radv_nir_lower_abi.c
+++ b/src/amd/vulkan/nir/radv_nir_lower_abi.c
@@ -516,7 +516,7 @@ radv_nir_lower_abi(nir_shader *shader, enum amd_gfx_level gfx_level, const struc
          state.gsvs_ring[i] = load_gsvs_ring(&b, &state, i);
 
       progress = true;
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
+      nir_progress(true, impl, nir_metadata_control_flow);
    }
 
    progress |= nir_shader_intrinsics_pass(shader, lower_abi_instr, nir_metadata_control_flow, &state);
diff --git a/src/amd/vulkan/nir/radv_nir_lower_cooperative_matrix.c b/src/amd/vulkan/nir/radv_nir_lower_cooperative_matrix.c
index b72d0697335..932dac57d37 100644
--- a/src/amd/vulkan/nir/radv_nir_lower_cooperative_matrix.c
+++ b/src/amd/vulkan/nir/radv_nir_lower_cooperative_matrix.c
@@ -521,11 +521,5 @@ radv_nir_lower_cooperative_matrix(nir_shader *shader, enum amd_gfx_level gfx_lev
 
    _mesa_hash_table_destroy(type_map, NULL);
 
-   if (progress) {
-      nir_metadata_preserve(func->impl, 0);
-   } else {
-      nir_metadata_preserve(func->impl, nir_metadata_all);
-   }
-
-   return progress;
+   return nir_progress(progress, func->impl, 0);
 }
diff --git a/src/amd/vulkan/nir/radv_nir_lower_primitive_shading_rate.c b/src/amd/vulkan/nir/radv_nir_lower_primitive_shading_rate.c
index a98a8280346..ba387a64012 100644
--- a/src/amd/vulkan/nir/radv_nir_lower_primitive_shading_rate.c
+++ b/src/amd/vulkan/nir/radv_nir_lower_primitive_shading_rate.c
@@ -84,10 +84,5 @@ radv_nir_lower_primitive_shading_rate(nir_shader *nir, enum amd_gfx_level gfx_le
          break;
    }
 
-   if (progress)
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   else
-      nir_metadata_preserve(impl, nir_metadata_all);
-
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_control_flow);
 }
diff --git a/src/amd/vulkan/nir/radv_nir_lower_ray_queries.c b/src/amd/vulkan/nir/radv_nir_lower_ray_queries.c
index 15a120d8090..217174c3cf4 100644
--- a/src/amd/vulkan/nir/radv_nir_lower_ray_queries.c
+++ b/src/amd/vulkan/nir/radv_nir_lower_ray_queries.c
@@ -719,7 +719,7 @@ radv_nir_lower_ray_queries(struct nir_shader *shader, struct radv_device *device
          }
       }
 
-      nir_metadata_preserve(function->impl, nir_metadata_none);
+      nir_progress(true, function->impl, nir_metadata_none);
    }
 
    ralloc_free(query_ht);
diff --git a/src/amd/vulkan/nir/radv_nir_rt_shader.c b/src/amd/vulkan/nir/radv_nir_rt_shader.c
index 63a561672f0..d1a3a656689 100644
--- a/src/amd/vulkan/nir/radv_nir_rt_shader.c
+++ b/src/amd/vulkan/nir/radv_nir_rt_shader.c
@@ -157,12 +157,7 @@ lower_rt_derefs(nir_shader *shader)
       }
    }
 
-   if (progress)
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   else
-      nir_metadata_preserve(impl, nir_metadata_all);
-
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_control_flow);
 }
 
 /*
@@ -789,10 +784,7 @@ lower_hit_attribs(nir_shader *shader, nir_variable **hit_attribs, uint32_t workg
    if (!hit_attribs)
       shader->info.shared_size = MAX2(shader->info.shared_size, workgroup_size * RADV_MAX_HIT_ATTRIB_SIZE);
 
-   if (progress)
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_control_flow);
 }
 
 static void
@@ -1210,7 +1202,7 @@ nir_lower_intersection_shader(nir_shader *intersection, nir_shader *any_hit)
          nir_def_rewrite_uses(&intrin->def, accepted);
       }
    }
-   nir_metadata_preserve(impl, nir_metadata_none);
+   nir_progress(true, impl, nir_metadata_none);
 
    /* We did some inlining; have to re-index SSA defs */
    nir_index_ssa_defs(impl);
@@ -1629,7 +1621,7 @@ radv_build_traversal(struct radv_device *device, struct radv_ray_tracing_pipelin
       radv_build_end_trace_token(b, vars, original_tmax, nir_load_var(b, trav_vars.hit),
                                  nir_load_var(b, iteration_instance_count));
 
-   nir_metadata_preserve(nir_shader_get_entrypoint(b->shader), nir_metadata_none);
+   nir_progress(true, nir_shader_get_entrypoint(b->shader), nir_metadata_none);
    radv_nir_lower_hit_attrib_derefs(b->shader);
 
    /* Register storage for hit attributes */
@@ -1748,7 +1740,7 @@ radv_build_traversal_shader(struct radv_device *device, struct radv_ray_tracing_
 
    /* Deal with all the inline functions. */
    nir_index_ssa_defs(nir_shader_get_entrypoint(b.shader));
-   nir_metadata_preserve(nir_shader_get_entrypoint(b.shader), nir_metadata_none);
+   nir_progress(true, nir_shader_get_entrypoint(b.shader), nir_metadata_none);
 
    /* Lower and cleanup variables */
    NIR_PASS(_, b.shader, nir_lower_global_vars_to_local);
@@ -2076,7 +2068,7 @@ radv_nir_lower_rt_abi(nir_shader *shader, const VkRayTracingPipelineCreateInfoKH
       radv_store_arg(&b, args, traversal_info, args->ac.rt.hit_kind, nir_load_var(&b, vars.hit_kind));
    }
 
-   nir_metadata_preserve(impl, nir_metadata_none);
+   nir_progress(true, impl, nir_metadata_none);
 
    /* cleanup passes */
    NIR_PASS(_, shader, nir_lower_global_vars_to_local);
diff --git a/src/amd/vulkan/radv_pipeline_rt.c b/src/amd/vulkan/radv_pipeline_rt.c
index fe9a320ec76..879320f4844 100644
--- a/src/amd/vulkan/radv_pipeline_rt.c
+++ b/src/amd/vulkan/radv_pipeline_rt.c
@@ -353,10 +353,8 @@ move_rt_instructions(nir_shader *shader)
       }
    }
 
-   if (progress)
-      nir_metadata_preserve(nir_shader_get_entrypoint(shader), nir_metadata_control_flow);
-
-   return progress;
+   return nir_progress(progress, nir_shader_get_entrypoint(shader),
+                       nir_metadata_control_flow);
 }
 
 static VkResult
diff --git a/src/asahi/compiler/agx_nir_lower_cull_distance.c b/src/asahi/compiler/agx_nir_lower_cull_distance.c
index 4120622ba67..9a9549b7a65 100644
--- a/src/asahi/compiler/agx_nir_lower_cull_distance.c
+++ b/src/asahi/compiler/agx_nir_lower_cull_distance.c
@@ -123,6 +123,5 @@ agx_nir_lower_cull_distance_fs(nir_shader *s, unsigned nr_distances)
                                            DIV_ROUND_UP(nr_distances, 4));
 
    s->info.fs.uses_discard = true;
-   nir_metadata_preserve(b->impl, nir_metadata_control_flow);
-   return true;
+   return nir_progress(true, b->impl, nir_metadata_control_flow);
 }
diff --git a/src/asahi/compiler/agx_nir_lower_discard_zs_emit.c b/src/asahi/compiler/agx_nir_lower_discard_zs_emit.c
index d4535d02817..7256e6d111e 100644
--- a/src/asahi/compiler/agx_nir_lower_discard_zs_emit.c
+++ b/src/asahi/compiler/agx_nir_lower_discard_zs_emit.c
@@ -129,13 +129,8 @@ agx_nir_lower_zs_emit(nir_shader *s)
          progress |= lower_zs_emit(block, s->info.fs.early_fragment_tests);
       }
 
-      if (progress) {
-         nir_metadata_preserve(impl, nir_metadata_control_flow);
-      } else {
-         nir_metadata_preserve(impl, nir_metadata_all);
-      }
-
-      any_progress |= progress;
+      any_progress = any_progress | nir_progress(progress, impl,
+                                                 nir_metadata_control_flow);
    }
 
    return any_progress;
